classdef siMeshElt < handle
  
  properties %(SetAccess = protected)
    d =0;
    dim=0;
    nq=0;
    nme=0;
    q  = [];
    me = [];
    toGlobal=[];
    nqGlobal=0;
    toParent=[]; % pour remplacer toGlobal;
    nqParent=0;  % pour remplacer nqGlobal;
    nqParents = []; %  nqParents(i)  i=1: parent, i=2:parent of parent, ...
    toParents = {};  
    label=0;
    Tag='';
    color=[];
    vols = [];
    gradBaCo =[];
    geolab =[];
    normals =[]; % outer unit normals to mesh boundaries,  nme-by-dim array 
    partlab={};
    bbox=[];
    h=0;
    order=1;
  end
  
  methods
    function self = siMeshElt(dim,d,label,q,me,toGlobal,nqGlobal,geolab,partlab,order)
      % must add tests
      if nargin==0; return;end
      if nargin>0
        if nargin==10,self.order=order;end
        self.dim=dim;
        self.d=d;
        self.label=label;
        self.q=q;
        self.nq=size(q,2);
        self.me=me;
        self.nme=size(me,2);
        if size(toGlobal,2)==1,toGlobal=toGlobal';end
        self.toGlobal=toGlobal;
        self.nqGlobal=nqGlobal;
        self.toParent=toGlobal;
        self.nqParent=nqGlobal;
        self.nqParents(1)=nqGlobal;
        self.toParents{1}=toGlobal;
        self.geolab=geolab;
        self.partlab=partlab;
%          self.vols=fc_meshtools.simplicial.Volumes_amat(self.q,self.me(1:d+1,:));
%          self.gradBaCo=fc_meshtools.simplicial.GradBaCo(self.q,self.me(1:d+1,:));
%          self.h=fc_meshtools.simplicial.getMaxLengthEdges(self.q,self.me(1:d+1,:));
%          self.bbox=zeros(1,2*dim); % bounding box
%          for i=1:dim,self.bbox(2*i-1:2*i)=[min(q(i,:)),max(q(i,:))];end
        set_geometry(self);
        
      end
    end 
    
%      function Ba=barycenters(self)
%        Ba=fc_meshtools.simplicial.barycenters(self.q,self.me(1:d+1,:));
%      end
    
    function self=copy(selfor)
      self=fc_simesh.siMeshElt();
      self.dim=selfor.dim;
      self.d=selfor.d;
      self.order=selfor.order;
      self.label=selfor.label;
      self.q=selfor.q;
      self.nq=selfor.nq;
      self.me=selfor.me;
      self.nme=selfor.nme;
      self.toGlobal=selfor.toGlobal;
      self.nqGlobal=selfor.nqGlobal;
      self.toParent=selfor.toParent;
      self.nqParent=selfor.nqParent;
      self.toParents=selfor.toParents;
      self.nqParents=selfor.nqParents;
      self.geolab=selfor.geolab;
      self.partlab=selfor.partlab;
      self.vols=selfor.vols;
      self.gradBaCo=selfor.gradBaCo;
      self.h=selfor.h;
      self.bbox=selfor.bbox;
      % Add 01/12/2019:
      self.label=selfor.label;
      self.order=selfor.order;
      self.color=selfor.color;
      self.Tag=selfor.Tag;
    end
    
    function move(self,U) % U dim-by-nq array
      %assert(size(U,1)==self.dim,'Mismatched dimensions of vector displacement array') 
      dimU=size(U,1);
      I=1:dimU;
      if dimU>self.dim 
        self.q(dimU,self.nq)=0;
        self.dim=dimU;
      end
      if size(U,2)==self.nq
        self.q(I,:)=self.q(I,:)+U;
      elseif size(U,2)==self.nqGlobal
        self.q(I,:)=self.q(I,:)+U(I,self.toGlobal);
      else
        warning('Unable to move mesh')
      end
      
    end
    
    function transform(self,fun) % U dim-by-nq array
      self.q=fun(self.q);
    end
    
    function idxme=cutIndex(self,P)
      idxme=1:self.nme;
      if isempty(P), return;end
      assert( isnumeric(P) && size(P,2)==4 );
      for i=1:size(P,1)
        idxme=setdiff(idxme,cutIndexPlan(self,P(i,:)));
      end
    end

    function idxme=cutIndexPlan(self,P)
        Point=[0;0;-P(4)]; %%%% BUG 
        idx=find(P(1:3)*(self.q-Point*ones(1,self.nq))<0);
        idxme=find(sum(ismember(self.me,idx),1)==0);
    end
    
    function disp(self)
    % FUNCTION disp, method function of the ooGmsh class.
    %   Displays informations on the ooGmsh object.
    %
    % Copyright (C) 2017-2022 F. Cuvelier
      fprintf('  siMeshElt with properties:\n')
      warning off
      names = fieldnames(self);
      maxnamelen=max(cellfun(@numel,names));
      for i=1:numel(names)
        n=eval(sprintf('size(self.%s)',names{i}));
        S=fillwith(names{i},' ',maxnamelen+4);
        fprintf('%s: ',S)
        printProperty(self,names{i})
      end
      warning on
    end    
    
    function printProperty(self,name)
      type=eval(sprintf('class(self.%s)',name));
      n=eval(sprintf('size(self.%s)',name));
      if sum(n)==0
        fprintf('[]\n');
      elseif ((n(1)==1) && (n(2)==1))
        if strcmp(type,'struct')
          fprintf('(1x1 struct)\n');
        elseif strcmp(type,'cell')
          fprintf('(1x1 cell)\n');
        else
          value=eval(sprintf('self.%s',name));
          fprintf('%g %s\n',value,type);
        end
      else

        if (prod(n)<=8)
          value=eval(sprintf('self.%s',name));
          if isnumeric(value)
            fprintf('[ ');fprintf('%g ',value);fprintf('] ');
          end
        end
        fprintf('(%d%s %s)\n',n(1),sprintf('x%d',n(2:end)),type);
        %fprintf('(%dx%d %s)\n',n(1),n(2),type);
      end
    end
    
    function u=eval(self,fun,varargin)
    % Eval fun on siMeshElt object and return an array with shape (self.nq,1)
    %        corresponding on the evaluate of fun on each mesh vertices (if fun is not a 
    %        list and not None)
    %        
    %        fun could be:
    %          - a scalar
    %          - a function handle
    %          - an array 
    %          - a cell array where each element could be on of the previous type

      p = inputParser;
      p.addParamValue('level',0);
      p.parse(varargin{:});
      R=p.Results;
      
      if fc_tools.utils.isfunhandle(fun)
        u=feval(self,fun,'level',R.level);
        return
      end
      
      if isnumeric(fun)
        u=NumericEvalOnVertices(self,fun,R.level);
        return
      end
      
      if iscell(fun)
        u=CellEvalOnVertices(self,fun,R.level);
        return
      end
      Info=whos('fun');
      error('Mismatched parameter fun: class=''%s'', size=[%s]',Info.class,num2str(Info.size))
    end

    function u=NumericEvalOnVertices(self,fun,level)

      if isscalar(fun)
        if level>0
          u=zeros(self.nqParents(level),1);
          u(self.toParents{level})=fun*ones(self.nq,1);
        else
          u=fun*ones(self.nq,1);
        end
        return
      end
      if ( size(fun,1)==self.nq && size(fun,2)==1 ) 
        if level>0
          u=zeros(self.nqParents(level),1);
          u(self.toParents{level})=fun;
        else
          u=fun;
        end
        return
      end
      if ( size(fun,2)==self.nq && size(fun,1)==1 ) 
        if level>0
          u=zeros(self.nqParents(level),1);
          u(self.toParents{level})=fun;
        else
          u=fun.';
        end
        return
      end
      Info=whos('fun');
      error('Mismatched numerical parameter fun: size=[%s], must be [1 %d] or [%d 1]!',num2str(Info.size),self.nq,self.nq)
    end

    function u=CellEvalOnVertices(self,fun,level)
      assert(size(fun,1)==1,'fun must be an 1-by-n cell array, given %d-by-%d ',size(fun))
      m=size(fun,2);
      if level==0
        u=zeros(m,self.nq);
      else
        u=zeros(m,self.nqParents(level));
      end
      for i=1:m
        u(i,:)=eval(self,fun,'level',level);
      end
    end    

    function obj=extractSubElement(this,label)
      partlab=cellfun(@(x) x(1),this.partlab)
      I=find(partlab==label);
      me=this.me(:,I);
      
    end
    
    function u=feval(self,fun,varargin)
      assert(fc_tools.utils.isfunhandle(fun))
      assert( ismember(nargin(fun),[1,self.dim]) ,'Number of function arguments must be 1 or %d',self.dim)
      p = inputParser;
      p.addParamValue('level',0,@isscalar); % mainly used with partition meshes?
      p.parse(varargin{:});
      R=p.Results;
      assert(ismember(R.level,0:length(self.nqParents)))
      
      if R.level>0
        u=zeros(self.nqParents(R.level),1);
        u(self.toParents{R.level})=fc_meshtools.eval(fun,self.q);  
      else
        u=fc_meshtools.eval(fun,self.q);
      end
    end

    function sTh=getBoundMesh(self)
      assert(self.d==2)
      NumLocEdges=nchoosek(1:(self.d+1),self.d);
      GlobalListEdges=[reshape(self.me(NumLocEdges(:,1),:),3*self.nme,1),reshape(self.me(NumLocEdges(:,2),:),3*self.nme,1)];

      Edges2Elements=ones(3,1)*[1:self.nme];
      Edges2Elements=Edges2Elements(:);

      Edges2LocalNum=[1; 2 ;3]*ones(1,self.nme);
      Edges2LocalNum=Edges2LocalNum(:);

      [GlobalListEdgesSort,IS]=sort(GlobalListEdges,2);
      [e2q,IG,IE]=unique(GlobalListEdgesSort,'rows','first');   
      e2t=Edges2Elements(IG,:);
      [e2ql,IGl,IEf]=unique(GlobalListEdgesSort,'rows','last');
      e2tl=Edges2Elements(IGl,:);
      Id=find(IG==IGl);
      e2tl(Id)=0;
      e2t=[e2t e2tl];
      I=find(e2t(:,2)==0);
      me=e2q(I,:)';
      sTh=siMeshElt(self.dim,self.d-1,self.label,self.q,me,[],0,[],[]);
      sTh.color=self.color;
    end
    
    function Ba=barycenters(self)
      Ba=fc_meshtools.simplicial.barycenters(self.q,self.me);
    end
    
    function ul=getLocalData(self,u)
      if length(u)==self.nqGlobal
        ul=u(self.toGlobal);
      elseif length(u)==self.nqParent
        ul=u(self.toParent);
      else
        assert(length(u)==self.nq);
        ul=u;
      end
    end
    
    function set_geometry(self)
      self.vols=fc_meshtools.simplicial.Volumes_amat(self.q,self.me(1:self.d+1,:));
      self.gradBaCo=fc_meshtools.simplicial.GradBaCo(self.q,self.me(1:self.d+1,:));
      self.h=fc_meshtools.simplicial.getMaxLengthEdges(self.q,self.me(1:self.d+1,:));
      self.bbox=zeros(1,2*self.dim); % bounding box
      for i=1:self.dim,self.bbox(2*i-1:2*i)=[min(self.q(i,:)),max(self.q(i,:))];end
    end
    
    function Normal=NormalFaces(this)
      % Normal (d+1)-by-d-by-nme 3D array
      %   
      d=this.d;
      [IndLocFaces,IndOpositePt]=fc_meshtools.simplicial.getIndLocFaces(d);
      Normal=zeros(d+1,this.dim,this.nme);
      %this
      for i=1:d+1
        %A=-squeeze(this.gradBaCo(:,IndOpositePt(i),:));
        A=-squeeze(this.gradBaCo(:,i,:));
        A=permute(A,[2,3,1]);
        %whos
        Normal(i,:,:)=A; % direction normal exterieur non normalisee au i-eme (d-1)-simplex dans le d-simplex
        N2=sqrt(sum(squeeze(Normal(i,:,:)).^2,1));
        for j=1:this.dim
          Normal(i,j,:)=squeeze(Normal(i,j,:))./N2';
        end
      end
    end
    
    function sgu=trace(self,u)
      assert(isnumeric(u))
      if length(u)==self.nqGlobal
        sgu=u(self.toGlobal);
      elseif length(u)==self.nq
        sgu=u;
      elseif length(u)==self.nqParent
        sgu=u(self.toParent);
      else
        error('Dimension of u mismatched')
      end
    end    
    
    function  vtuWrite(Th,FileName,varargin)
    % function  vtkWrite(FileName,Th,varargin)
    %   Write mesh Th and U in a VTK file.
    %
    % Parameters:
    %   FileName : VTK file name,
    %   Th : a 2D or 3D mesh
    %   U  : an array of cells which contains all the values to save in VTK file,
    %   names : an array of cells which contains all the names of the values to save in VTK file.
    %
    % Samples:
    %   % Save scalar values
    %   Th=GetMesh3DOpt('sphere-1-10.mesh','fromet','medit');
    %   U=cos(Th.q(1,:).^2+Th.q(2,:).^2+Th.q(3,:).^2);
    %   V=cos(Th.q(1,:).^2+Th.q(2,:).^2+Th.q(3,:).^2);
    %   vtkWrite('sample01.vtk',Th,{U,V},{'u','v'})
    %
    %   % Save vector values
    %   U{1}=Th.q(1,:).^2+Th.q(2,:).^2+Th.q(3,:).^2;
    %   U{2}=cos(U{1});
    %   U{3}=sin(U{1});
    %   vtkWrite('sample02.vtk',Th,{[U{1},U{2},U{3}]},{'U'})
    %
      p = inputParser;
      p.addParamValue('Values',{},@(x) iscell(x) || isnumeric(x) );
      p.addParamValue('Names',{},@(x) (iscell(x) || ischar(x)));
      p.parse(varargin{:});
      U=p.Results.Values;
      names=p.Results.Names;
      %>>> [FC] : to improve
      if isnumeric(U), U={U};end  
      if ischar(names), names={names};end

      fid=fopen(FileName,'w');
      fprintf(fid,'<VTKFile type="UnstructuredGrid" version="0.1" byte_order="BigEndian">\n');
      fprintf(fid,'\t<UnstructuredGrid>\n');
      fprintf(fid,'\t\t<Piece NumberOfPoints="%d" NumberOfCells="%d">\n',Th.nq,Th.nme);
      %>>> Write Points
      fprintf(fid,'\t\t\t<Points>\n');
      dim=Th.dim;
      fprintf(fid,'\t\t\t\t<DataArray type="Float32" NumberOfComponents="%d" Format="ascii">\n',dim);
      format=['\t\t\t\t\t',repmat('%.16f ',1,dim),'\n']; 
      fprintf(fid,format,Th.q);
      fprintf(fid,'\t\t\t\t</DataArray>\n');
      fprintf(fid,'\t\t\t</Points>\n');
      %<<<
      %>>> Write Cells
      fprintf(fid,'\t\t\t<Cells>\n');
      fprintf(fid,'\t\t\t\t<DataArray type="Int32" Name="connectivity" Format="ascii">\n');
      d=size(Th.me,1);
      if d==4,type=10;end % VTK_TETRA (=10)
      if d==3,type=5;end % VTK_TRIANGLE (=5)
      format=['\t\t\t\t\t',repmat('%d ',1,dim),'\n'];
      fprintf(fid,format,Th.me-1);
      fprintf(fid,'\t\t\t\t</DataArray>\n');
      fprintf(fid,'\t\t\t\t<DataArray type="Int32" Name="offsets" Format="ascii">\n');
      d=size(Th.me,1);
      format='\t\t\t\t\t%%d\n';
      offset=d*[1:Th.nme]';
      fprintf(fid,'\t\t\t\t\t%d\n',offset);
      fprintf(fid,'\t\t\t\t</DataArray>\n');
      fprintf(fid,'\t\t\t\t<DataArray type="Int32" Name="types" Format="ascii">\n');
      d=size(Th.me,1);
      format='\t\t\t\t\t%%d\n';
      fprintf(fid,'\t\t\t\t\t%d\n',type*ones(Th.nme,1));
      fprintf(fid,'\t\t\t\t</DataArray>\n');
      fprintf(fid,'\t\t\t</Cells>\n');
      %<<<
      fprintf(fid,'\t\t\t<PointData Scalars="scalars">\n');
      if ~isempty(U)
        assert(iscell(U) & iscell(names));
        assert(length(U)==length(names));
        n=length(U);
        for i=1:n
          vtuWriteValues(Th,fid,U{i},names{i});
        end
      end
      fprintf(fid,'\t\t\t</PointData>\n');
      fprintf(fid,'\t\t</Piece>\n');
      fprintf(fid,'\t</UnstructuredGrid>\n');
      fprintf(fid,'</VTKFile>\n');
      fclose(fid); 
    end

    function  vtkWrite(self,FileName,varargin)
    % function  vtkWrite(FileName,Th,U,names)
    %   Write mesh element and U in a VTK file.
    %
    % Parameters:
    %   FileName : VTK file name,
    %   U  : an array of cells which contains all the values to save in VTK file,
    %   names : an array of cells which contains all the names of the values to save in VTK file.
    %
    % Samples:
    %   % Saving scalar values
    %   Th=GetMesh3DOpt('sphere-1-10.mesh','format','medit');
    %   U=cos(Th.q(1,:).^2+Th.q(2,:).^2+Th.q(3,:).^2);
    %   V=cos(Th.q(1,:).^2+Th.q(2,:).^2+Th.q(3,:).^2);
    %   vtkWrite('sample01.vtk',Th,{U',V'},{'u','v'})
    %
    %   % Saving vector values
    %   U{1}=Th.q(1,:).^2+Th.q(2,:).^2+Th.q(3,:).^2;
    %   U{2}=cos(U{1});
    %   U{3}=sin(U{1});
    %   vtkWrite('sample02.vtk',Th,{[U{1},U{2},U{3}]},{'U'})
    %
      p = inputParser;
      p.addParamValue('Values',{},@(x) iscell(x) || isnumeric(x) );
      p.addParamValue('Names',{},@(x) (iscell(x) || ischar(x)));
      p.parse(varargin{:});
      U=p.Results.Values;
      names=p.Results.Names;
      %>>> [FC] : to improve
      if isnumeric(U), U={U};end  
      if ischar(names), names={names};end
      %<<<
      fid=fopen(FileName,'w');
      vtkWriteMesh(self,fid);
      if ~isempty(U)
        fprintf(fid,'POINT_DATA %d\n',self.nq);
        assert(iscell(U) & iscell(names));
        assert(length(U)==length(names));
        n=length(U);
        for i=1:n
          if size(U{i},2)==self.nq, U{i}=U{i}';end
          assert(size(U{i},1)==self.nq);
          vtkWriteValues(fid,U{i},names{i});
        end
      end
      fclose(fid);
    end
    
    
%% GRAPHICS
    function varargout=plotmesh(self,varargin)
      if fc_tools.utils.is_fcPackage('graphics4mesh')
        varargout=cell(1,nargout);
        [varargout{:}]=fc_graphics4mesh.plotmesh(self.q,self.me,varargin{:});
      else
        if fc_tools.comp.isOctave(), name='package';else, name='toolbox';end
        warning('Unable to load fc_graphics4mesh %s',name)
      end
    end
    
    function varargout=plot(self,u,varargin)
      if fc_tools.utils.is_fcPackage('graphics4mesh')
        varargout=cell(1,nargout);
        [varargout{:}]=fc_graphics4mesh.plot(self.q,self.me,u,varargin{:});
      else
        if fc_tools.comp.isOctave(), name='package';else, name='toolbox';end
        warning('Unable to load fc_graphics4mesh %s',name)
      end
    end
    
    function varargout=scatter(self,u,varargin)
      if fc_tools.utils.is_fcPackage('graphics4mesh')
        varargout=cell(1,nargout);
        [varargout{:}]=fc_graphics4mesh.scatter(self.q,u,varargin{:});
      else
        if fc_tools.comp.isOctave(), name='package';else, name='toolbox';end
        warning('Unable to load fc_graphics4mesh %s',name)
      end
    end
    
    function varargout=plotiso(self,u,varargin)
      if fc_tools.utils.is_fcPackage('graphics4mesh')
        varargout=cell(1,nargout);
        [varargout{:}]=fc_graphics4mesh.plotiso(self.q,self.me,u,varargin{:});
      else
        if fc_tools.comp.isOctave(), name='package';else, name='toolbox';end
        warning('Unable to load fc_graphics4mesh %s',name)
      end
    end
    
    function varargout=plotquiver(self,V,varargin)
      if fc_tools.utils.is_fcPackage('graphics4mesh')
        varargout=cell(1,nargout);
        [varargout{:}]=fc_graphics4mesh.plotquiver(self.q,self.me,V,varargin{:});
      else
        if fc_tools.comp.isOctave(), name='package';else, name='toolbox';end
        warning('Unable to load fc_graphics4mesh %s',name)
      end
    end
        
    function varargout=slicemesh(self,P,varargin)
      if fc_tools.utils.is_fcPackage('graphics4mesh')
        varargout=cell(1,nargout);
        [varargout{:}]=fc_graphics4mesh.slicemesh(self.q,self.me,P,varargin{:});
      else
        if fc_tools.comp.isOctave(), name='package';else, name='toolbox';end
        warning('Unable to load fc_graphics4mesh %s',name)
      end
    end
    
    function varargout=slice(self,P,u,varargin)
      if fc_tools.utils.is_fcPackage('graphics4mesh')
        varargout=cell(1,nargout);
        [varargout{:}]=fc_graphics4mesh.slice(self.q,self.me,u,P,varargin{:});
      else
        if fc_tools.comp.isOctave(), name='package';else, name='toolbox';end
        warning('Unable to load fc_graphics4mesh %s',name)
      end
    end
    
    function varargout=sliceiso(self,P,u,varargin)
      if fc_tools.utils.is_fcPackage('graphics4mesh')
        varargout=cell(1,nargout);
        [varargout{:}]=fc_graphics4mesh.sliceiso(self.q,self.me,u,P,varargin{:});
      else
        if fc_tools.comp.isOctave(), name='package';else, name='toolbox';end
        warning('Unable to load fc_graphics4mesh %s',name)
      end
    end
    
    function varargout=plotGradBaCo(self,varargin)
      if fc_tools.utils.is_fcPackage('graphics4mesh')
        varargout=cell(1,nargout);
        [varargout{:}]=fc_graphics4mesh.plotGradBaCo(self.q,self.me,'GradBaCo',self.gradBaCo,varargin{:});
      else
        if fc_tools.comp.isOctave(), name='package';else, name='toolbox';end
        warning('Unable to load fc_graphics4mesh %s',name)
      end
    end
    
    function varargout=plotelementsidx(self,varargin)
      if fc_tools.utils.is_fcPackage('graphics4mesh')
        varargout=cell(1,nargout);
        [varargout{:}]=fc_graphics4mesh.plotelementsidx(self.q,self.me,varargin{:});
      else
        if fc_tools.comp.isOctave(), name='package';else, name='toolbox';end
        warning('Unable to load fc_graphics4mesh %s',name)
      end
    end
    
    function varargout=plotnodes(self,varargin)
      if fc_tools.utils.is_fcPackage('graphics4mesh')
        varargout=cell(1,nargout);
        [varargout{:}]=fc_graphics4mesh.plotnodes(self.q,varargin{:});
      else
        if fc_tools.comp.isOctave(), name='package';else, name='toolbox';end
        warning('Unable to load fc_graphics4mesh %s',name)
      end
    end
    
    function varargout=plotnodesidx(self,varargin)
      if fc_tools.utils.is_fcPackage('graphics4mesh')
        p = inputParser; 
        p.KeepUnmatched=true; 
        p.PartialMatching=false;
        %p.addParamValue('Global',false,@islogical);
        p.addParamValue('Global',0,@(x) ismember(x,[-1,0:length(self.toParents)]));  % 0: local, otherwise global level (1 is usual), -1, last
        p.parse(varargin{:});
        R=p.Results;
        if R.Global==-1,R.Global=length(self.toParents);end
        if R.Global==0, toGlobal=[];else, toGlobal=self.toParents{R.Global};end
%        if R.Global, toGlobal=self.toGlobal;else, toGlobal=[];end 
        varargin=fc_tools.utils.deleteCellOptions(varargin,p.Parameters);
        varargout=cell(1,nargout);
        [varargout{:}]=fc_graphics4mesh.plotnodesidx(self.q,'toGlobal',toGlobal,varargin{:});
      else
        if fc_tools.comp.isOctave(), name='package';else, name='toolbox';end
        warning('Unable to load fc_graphics4mesh %s',name)
      end
    end
  end  
end

function S=fillwith(name,c,nmax)
  n=numel(name);
  S=[repmat(c,1,nmax-n),name];
end

function vtuWriteValues(Th,fid,U,name)
  assert(isnumeric(U));
  if length(U)==Th.nq
    sel=@(X) X;
  elseif length(U)==Th.nqParent
    sel=@(X) X(Th.toParent);
  elseif length(U)==Th.nqGlobal
    sel=@(X) X(Th.toGlobal);
  else
    whos
    assert(0)
  end
  d=size(U,2);
  nq=Th.nq;
  assert(d<=3);
  if d==1
    fprintf(fid,'\t\t\t\t<DataArray type="Float32" Name="%s" Format="ascii">\n',name);
    fprintf(fid,'\t\t\t\t\t%.16f\n',sel(U));
    fprintf(fid,'\t\t\t\t</DataArray>\n');
  else
    X=zeros(3,nq);for i=1:d, X(i,:)=sel(U(:,i));end
    fprintf(fid,'\t\t\t\t<DataArray type="Float32" Name="%s" NumberOfComponents="3" Format="ascii">\n',name);
    fprintf(fid,'\t\t\t\t\t%.16f %.16f %.16f\n',X);
    fprintf(fid,'\t\t\t\t</DataArray>\n');
  end
  fprintf(fid,'\n');
end

function vtkWriteMesh(Th,fid)
  if ischar(fid), fid=fopen(fid,'w');end
  fprintf(fid,'# vtk DataFile Version 2.0\n');
  fprintf(fid,'Generated Volume Mesh\n');
  fprintf(fid,'ASCII\n');
  fprintf(fid,'DATASET UNSTRUCTURED_GRID\n');
  fprintf(fid,'POINTS %d float\n',Th.nq);
  if Th.d==3
    fprintf(fid,'%.16f %.16f %.16f\n',Th.q);
%      for i=1:Th.nq
%        fprintf(fid,'%g %g %g\n',Th.q(1,i),Th.q(2,i),Th.q(3,i));
%      end

    fprintf(fid,'CELLS %d %d\n',Th.nme,5*Th.nme);
    fprintf(fid,'4 %d %d %d %d\n',Th.me-1);
%      for k=1:Th.nme
%        fprintf(fid,'4 %d %d %d %d\n',Th.me(1,k)-1,Th.me(2,k)-1,Th.me(3,k)-1,Th.me(4,k)-1);
%      end
    fprintf(fid,'CELL_TYPES %d\n',Th.nme);
    fprintf(fid,'%d\n',10*ones(Th.nme,1));
%      for k=1:Th.nme
%        fprintf(fid,'10\n'); % 10 for tetrahedra
%      end
  else
    if size(Th.q,1)==2
      fprintf(fid,'%.16f %.16f 0\n',Th.q);
%        for i=1:Th.nq
%  	fprintf(fid,'%g %g 0\n',Th.q(1,i),Th.q(2,i));
%        end
    else
      fprintf(fid,'%.16f %.16f %.16f\n',Th.q);
%        for i=1:Th.nq
%  	fprintf(fid,'%g %g %g\n',Th.q(1,i),Th.q(2,i),Th.q(3,i));
%        end
    end

    fprintf(fid,'CELLS %d %d\n',Th.nme,4*Th.nme);
    fprintf(fid,'3 %d %d %d \n',Th.me-1);
%      for k=1:Th.nme
%        fprintf(fid,'3 %d %d %d \n',Th.me(1,k)-1,Th.me(2,k)-1,Th.me(3,k)-1);
%      end
    fprintf(fid,'CELL_TYPES %d\n',Th.nme);
    fprintf(fid,'%d\n',5*ones(Th.nme,1));
%      for k=1:Th.nme
%        fprintf(fid,'5\n'); % 5 for triangles
%      end
  end
  fprintf(fid,'\n');
end

function vtkWriteValues(fid,U,name)
  assert(isnumeric(U));
  d=size(U,2);
  nq=size(U,1);
  assert(d<=3);
  if d==1
    fprintf(fid,'SCALARS %s float 1\n',name);
    fprintf(fid,'LOOKUP_TABLE table_%s\n',name);
    fprintf(fid,'%.16f\n',U);
  else
    X=zeros(nq,3);for i=1:d, X(:,i)=U(:,i);end
    fprintf(fid,'VECTORS vectors float\n');
    format=[repmat('%.16f ',1,d),'\n'];
    fprintf(fid,format,X);
%      for i=1:nq
%        fprintf(fid,'%g ',X(i,:));fprintf(fid,'\n');
%      end
  end
  fprintf(fid,'\n');
end
